/*
   FIR Synthesizer

   Version 0.1

   yerpa58 (2008)
*/

//
// global variables
//

// "API" Potentiometer 0..7 values:
// int8 API_POT[8];

int8  FIR_out       = 0x7f;


void DSP_FIR_Init (void)
{
   int16 i;
   int8 noise;
   noise = 0x1d;
   for (i=0; i<512; i++)
   {
     noise <<=1;
     if (noise & 0x80) noise ^= 0xe1;
     BUFFER1[i]=noise;
   }

   FIR_out       = 0x7f;

}


void DSP_FIR2_Init (void)
{
   int16 i;
   int8 noise;
   noise = 0x1d;
   for (i=0; i<512; i++)
   {
     noise <<=1;
     if (noise & 0x80) noise ^= 0xc5;
     BUFFER2[i]=noise;
   }

   FIR_out       = 0x7f;

}

int8 DSP_FIR_1 (int1 reverse)
{
   static int16  index1a  = 0;
   static int16  index1b  = 0xff;
   static int16  index2a  = 0;
   static int16  index2b  = 0x3f;
   static int16  acc1     = 0x7f;
   static int16  acc2     = 0x7f;

   static int16  buff_len_1;
   static int16  old_len_1;
   static int16  buff_len_2;
   static int16  old_len_2;
   static int16  FIR_out;

   buff_len_1 = API_POT[5]>>3;
   if (buff_len_1 != old_len_1)
   {
      DSP_FIR_Init();
      old_len_1 = buff_len_1;
      index1a = 0;
   }

   buff_len_2 = (API_POT[6] & 0xFC)<<1;
   if (buff_len_2 != old_len_2)
   {
      DSP_FIR2_Init();
      old_len_2 = buff_len_2;
      index2a = 0;
   }


   index1b = index1a + buff_len_1;
   if (index1b > buff_len_1)
   {
      index1b=index1b-buff_len_1;
      index1b=index1b-1;
   }
   acc1 = BUFFER1[index1a] + BUFFER1[index1b];
   acc1 >>=1;
   acc1 &= 0xFF;
   BUFFER1[index1b] = acc1;
   index1a++;
   if (index1a > buff_len_1)
   {
     index1a=index1a-buff_len_1;
     index1a=index1a-1;
   }

   index2b = index2a + buff_len_2;
   if (index2b > buff_len_2)
   {
      index2b=index2b-buff_len_2;
      index2b=index2b-1;
   }
   acc2 = BUFFER2[index2a] + BUFFER2[index2b];
   acc2 >>=1;
   acc2 &= 0xFF;
   BUFFER2[index2b] = acc2;
   index2a++;
   if (index2a > buff_len_2)
   {
     index2a=index2a-buff_len_2;
     index2a=index2a-1;
   }

   FIR_out = acc1+acc2;

   return FIR_out;
}
